<template>
  <FloatingCreateButton
    :shown="isShown"
    @click="isShown = true"
  />

  <v-bottom-sheet
    v-model="isShown"
    fullscreen
    persistent
  >
    <v-sheet class="p-6">
      <section class="flex justify-between items-center">
        <FormHeader
          icon="mdi-plus"
          headline="Новое бронирование"
          subtitle="Заполните данные"
        />

        <v-btn
          icon="mdi-close"
          variant="text"
          @click="isCloseConfirmShown = true"
        />
      </section>

      <v-divider class="border-gray-800 my-4" />

      <section class="flex items-start w-full mx-auto">
        <section class="hidden md:block w-1/4 mr-4 sticky top-0">
          <Timeline :booking="newBooking" />
        </section>

        <section class="flex-auto">
          <FormRow>
            <section>
              <h2 class="text-3xl font-light required-asterisk">
                Объект
              </h2>

              <span class="text-gray-500">
                Выберите объект и даты, которые будут забронированы
              </span>
            </section>

            <section class="mt-4">
              <PropertySelection v-model="newBooking.property" />
            </section>

            <section class="mt-4 relative">
              <DatesSelection
                v-model="newBooking.dates"
                :property="newBooking.property"
              />

              <v-overlay
                v-model="isDatesDisabled"
                scrim="white"
                contained
                persistent
              />
            </section>
          </FormRow>

          <FormRow spacing="xl">
            <section>
              <h2 class="text-3xl font-light required-asterisk">
                Тариф
              </h2>

              <span class="text-gray-500">
                Выберите нужный тариф
              </span>
            </section>

            <section class="mt-4 relative">
              <RateSelection v-model="newBooking.rate" />
            </section>
          </FormRow>

          <FormRow spacing="xl">
            <section>
              <h2 class="text-3xl font-light required-asterisk">
                Гости
              </h2>

              <span class="text-gray-500">
                Укажите количество гостей и контактное лицо
              </span>
            </section>

            <section class="mt-4 relative">
              <GuestsSelection
                v-model:contact="newBooking.guests.contact"
                v-model:adults="newBooking.guests.count.adults"
                v-model:children="newBooking.guests.count.children"
                :property="newBooking.property"
              />
            </section>
          </FormRow>

          <FormRow spacing="xl">
            <section>
              <h2 class="text-3xl font-light">
                Услуги
              </h2>

              <span class="text-gray-500">
                Выберите дополнительные услуги
              </span>
            </section>

            <section class="mt-4 relative">
              <AmenitiesSelection v-model="newBooking.amenities" />
            </section>
          </FormRow>

          <FormRow spacing="xl">
            <section>
              <h2 class="text-3xl font-light">
                Коррекции
              </h2>

              <span class="text-gray-500">
                Добавьте любые коррекции бронирования
              </span>
            </section>

            <section class="mt-4 relative">
              <CorrectionsSelection v-model="newBooking.corrections" />
            </section>
          </FormRow>

          <FormRow spacing="xl">
            <section>
              <h2 class="text-3xl font-light">
                Комментарий
              </h2>

              <span class="text-gray-500">
                Комментарий отобразится на странице бронирования
              </span>
            </section>

            <section class="mt-4 relative">
              <v-textarea
                v-model="newBooking.comment"
                :maxlength="MAX_BOOKING_COMMENT_LENGTH"
                prepend-inner-icon="mdi-comment-edit-outline"
                variant="solo-filled"
                persistent-counter
                clearable
                auto-grow
                flat
                counter
              />
            </section>
          </FormRow>

          <v-divider class="border-gray-800 my-4" />

          <FormRow
            spacing="large"
            class="w-3/5 mx-auto"
          >
            <v-btn
              block
              rounded
              size="large"
              class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
              :class="{ 'opacity-50': !isDataFilled }"
              :readonly="!isDataFilled"
              @click="isSummaryShown = true"
            >
              Продолжить
            </v-btn>
          </FormRow>

          <FormRow>
            <v-btn
              block
              rounded
              size="small"
              variant="plain"
              :ripple="false"
              class="font-bold"
              @click="isCloseConfirmShown = true"
            >
              Отмена
            </v-btn>
          </FormRow>
        </section>

        <!-- This block helps to center the content -->
        <section class="hidden lg:block w-1/4 ml-4" />
      </section>
    </v-sheet>
  </v-bottom-sheet>

  <Summary
    :booking="newBooking"
    :is-shown="isSummaryShown"
    @close="isSummaryShown = false"
    @booking-create="onBookingCreate"
  />

  <ConfirmationDialog
    v-model="isCloseConfirmShown"
    :is-loading="false"
    @confirm="onCloseConfirmClick"
  >
    Вы действительно хотите отменить создание бронирования?
    Заполненные данные будут утеряны
  </ConfirmationDialog>
</template>

<script setup lang="ts">
import { computed, reactive, ref } from 'vue';

import { MAX_BOOKING_COMMENT_LENGTH } from '@/declarations';
import { sleep } from '@/utils';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import ConfirmationDialog from '@/components/layout/ConfirmationDialog.vue';
import FloatingCreateButton from '@/components/layout/FloatingCreateButton.vue';

import Timeline from './Timeline.vue';
import Summary from './Summary.vue';

import PropertySelection from './PropertySelection.vue';
import DatesSelection from './DatesSelection.vue';
import RateSelection from './RateSelection.vue';
import GuestsSelection from './GuestsSelection.vue';
import AmenitiesSelection from './AmenitiesSelection.vue';
import CorrectionsSelection from './corrections/CorrectionsSelection.vue';

const newBooking = reactive<INewBooking>({
  property: null,
  dates: null,
  rate: null,
  guests: {
    contact: null,
    count: { adults: 0, children: 0 },
  },
  amenities: [],
  corrections: [],
  comment: '',
});

const isCloseConfirmShown = ref(false);
const isShown = ref(false);
const isSummaryShown = ref(false);

const isDatesDisabled = computed(() => !newBooking.property);

const isDataFilled = computed(() => {
  const isPropertySelected = Boolean(newBooking.property);
  const isDatesSelected = Boolean(newBooking.dates);
  const isRateSelected = Boolean(newBooking.rate);
  const isContactSelected = Boolean(newBooking.guests.contact);
  const isAdultsSpecified = newBooking.guests.count.adults > 0;

  return (
    isPropertySelected &&
    isDatesSelected &&
    isRateSelected &&
    isContactSelected &&
    isAdultsSpecified
  );
});

const resetForm = () => {
  newBooking.property = null;
  newBooking.dates = null;
  newBooking.rate = null;

  newBooking.guests = {
    contact: null,
    count: { adults: 0, children: 0 },
  };

  newBooking.amenities = [];
  newBooking.corrections = [];

  newBooking.comment = '';
};

const onCloseConfirmClick = () => {
  isCloseConfirmShown.value = false;
  isShown.value = false;

  resetForm();
};

const onBookingCreate = async () => {
  isCloseConfirmShown.value = false;
  isSummaryShown.value = false;

  // Improve UX using delay before closing
  await sleep(300);
  isShown.value = false;

  resetForm();
};
</script>